/** SGX

The   sss    gggg x   x   
     s      g      x x    Engine
      sss   g  gg   x
         s  g   g  x x          Copyright 1995-2009.
     ssss    gggg x   x         Steven Goodwin. All Rights Reserved.
    
This version has been released under the GNU Public License v2.0.

Please see the license files for details.

File: sgx/include/sgx/core/threading/atomiclock.hpp

*/

#ifndef SGX_ATOMIC_LOCK
#define SGX_ATOMIC_LOCK	1

class CAtomicLock {
public:
	CAtomicLock();

	tBOOL	inc();		// Returns TRUE if there is now a lock on it
	tBOOL	dec();		// Returns TRUE when the lock has been removed

	tUINT32 getCount();

protected:
	tUINT32	m_LockCount;
};

#endif /* SGX_ATOMIC_LOCK */
	